#!/bin/sh

set -e

cd $(dirname $0)

. ../../../common/config.sh
. ../../../common/log.sh

log_start "$0" "chgpasswd checks if the group file is locked"

save_config

# restore the files on exit
trap 'log_status "$0" "FAILURE"; restore_config; rm -f /etc/group.lock' 0

change_config

echo -n "Create lock file for /etc/group..."
touch /etc/group.lock
echo "done"

echo -n "Change passwords (chgpasswd -e)..."
echo 'nogroup:test
lp:test2' | chgpasswd -e 2>tmp/chgpasswd.err && exit 1 || {
	status=$?
}
echo "OK"

rm -f /etc/group.lock

echo -n "Check returned status ($status)..."
test "$status" = "1"
echo "OK"

echo "chgpasswd reported:"
echo "======================================================================="
cat tmp/chgpasswd.err
echo "======================================================================="
echo -n "Check that there were a failure message..."
diff -au data/chgpasswd.err tmp/chgpasswd.err
echo "error message OK."
rm -f tmp/chgpasswd.err

echo -n "Check the passwd file..."
../../../common/compare_file.pl config/etc/passwd /etc/passwd
echo "OK"
echo -n "Check the group file..."
../../../common/compare_file.pl config/etc/group /etc/group
echo "OK"
echo -n "Check the shadow file..."
../../../common/compare_file.pl config/etc/shadow /etc/shadow
echo "OK"
echo -n "Check the gshadow file..."
../../../common/compare_file.pl config/etc/gshadow /etc/gshadow
echo "OK"

log_status "$0" "SUCCESS"
restore_config
trap '' 0

